Skip to main content Skip to footer

How to Import and Export CSV Files Using JavaScript

  • 0 Comments
Quick Start Guide
What You Will Need

SpreadJS

NPM

Visual Studio Code

Controls Referenced SpreadJS
Tutorial Concept Import/Export CSV JavaScript - Add the functionality to import and export CSV files in your web application using SpreadJS features.

SJS CSV

In the ever-evolving landscape of web development, JavaScript reigns supreme as a versatile and powerful language. As JavaScript developers, we often find ourselves tasked with handling data in various formats, and one common requirement is working with CSV files. Whether you need to import data from external sources, perform data analysis, or simply present information in a structured tabular format, knowing how to import, modify data, and export CSV files can be a game-changer. In this blog, we will explore the ins and outs of CSV file manipulation in a JavaScript spreadsheet solution. We'll take it a step further by introducing you to SpreadJS, a robust JavaScript spreadsheet component to load CSV data, visualize it within a JS spreadsheet, and export it to a CSV file. So, let's dive in and unlock the potential of seamless CSV file handling in the world of JavaScript development.

Follow the steps below to import and export CSV files in a JavaScript spreadsheet application:

  1. Add SpreadJS to a JavaScript App
  2. Add HTML Buttons for Import and Export
  3. Import CSV Data to JS App Using SpreadJS’s setCsv Method
  4. Export JS Data to a CSV File Using SpreadJS’s getCsv Method

To follow along with this tutorial, you can download the sample

Ready to Get Started? Download SpreadJS Today!

Add SpreadJS to a JavaScript App

To get started with this example, create an app, reference SpreadJS’s files, and initialize the JavaScript spreadsheet component. In this case, we can use NPM to install the required SpreadJS files:

npm install @mescius/spread-sheets

Then, we need to reference those files in the code:

<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <!-- Add the SpreadJS Script file-->
    <script
        src="./node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js"
        type="text/javascript"></script>
    <!-- Add the SpreadJS CSS File-->
    <link rel="stylesheet" type="text/css"
        href="./node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
    <style>
        .spread-container {
            height: 550px;
        }
    </style>
</head>
<body>
    <h1>SpreadJS - Import and Export CSV Data</h1>
    <div class="sample-container">
        <!-- Create SpreadJS's target DOM element, HTML DIV with id ss-->
        <div id="ss" class="spread-container"></div>
    </div>
</body>
<script>
  var spread;
    // Initialize SpreadJS in spread-container by div's id "ss"
    window.onload = function ()
    {
        spread = new GC.Spread.Sheets.Workbook("ss", { sheetCount: 1 });
    };
</script>
</html>

This is how SpreadJS will appear:

SJS IO CSV Data

Add HTML Buttons for Import and Export

Next, add two buttons and a file selector input to the webpage:

<body>
    <h1>SpreadJS - Import and Export CSV Data</h1>
    <!-- Add file selector Import/Export buttons -->
    <input id="selectedFile" type="file" name="files[]" accept=".csv" />
    <button onclick="importCSV()">Import CSV</button>
    <button onclick="exportCSV()">Export CSV</button>

    <div class="sample-container">
        <!-- Create SpreadJS's target DOM element, HTML DIV with id ss-->
        <div id="ss" class="spread-container"></div>
    </div>
</body>

Then, create onclick events for both of the buttons:

<script>
    var spread;
    // Initialize SpreadJS in spread-container by div's id "ss"
    window.onload = function ()
    {
        spread = new GC.Spread.Sheets.Workbook("ss", { sheetCount: 1 });
    };
    // Import/Export button onclick functions
    function importCSV() {
            console.log("import button");
        }
    function exportCSV() {
            console.log("export button");
    }
</script>

After implementing this code, we can see the file selector and the button onclick functions are working properly:

Import Export Csv Console

Import CSV Data to JS App Using SpreadJS’s setCsv Method

To import CSV data, invoke SpreadJS’s setCsv method within the importCSV function. The setCsv method has a rowDelimiter and columnDelimiter as the fourth and fifth parameters, respectively. These can be changed to different symbols; for example, changing the columnDelimiter from “,” to “\t”, which will support TSV files as well. In the case of this example, we are just going to use commas. We need to retrieve the file from the input, read it as text, and then use setCsv:

// Import button onclick functions
function importCSV() {
    var file = document.getElementById("selectedFile").files[0];
    let reader = new FileReader();
    reader.readAsText(file);
    reader.onload = function (event) {
        var csv = event.target.result;
        spread.getSheet(0).setCsv(0, 0, csv, "\r", ",");
    }
}

Export CSV Data from JS App Using SpreadJS’s getCsv Method

Alternatively, to export CSV data, we need to use the getCsv method within the exportCSV function. This will require a little more code to enable the exported file to be downloaded from the browser so we can create a download function:

// Function to download the CSV file
const download = (data) => {
  // Create a Blob with the CSV data and type
  const blob = new Blob([data], { type: 'text/csv' });
  // Create a URL for the Blob
  const url = URL.createObjectURL(blob);
  // Create an anchor tag for downloading
  const a = document.createElement('a');
  // Set the URL and download attribute of the anchor tag
  a.href = url;
  a.download = 'download.csv';
  // Trigger the download by clicking the anchor tag
  a.click();
}

Now that we have that function set up, we can retrieve the CSV content with the getCsv method and then pass that to the download function we just created:

// Export button onclick function
function exportCSV() {
    console.log("export button");
    var csvContent = spread.getSheet(0).getCsv(0, 0, spread.getSheet(0).getRowCount(), spread.getSheet(0).getColumnCount(), "\r", ",");
    download(csvContent);
}

That’s all that is needed to import and export CSV files with SpreadJS:

Import Export Csv From Browser

Ready to Try It Out? Download SpreadJS Today!

Conclusion

With a small amount of SpreadJS code, you can add CSV import and export functionality to your app, providing your users the ability to load and save their data. For more information about SpreadJS and examples, check out our Demos and Documentation, and download a trial of SpreadJS today!

Tags:

Skip to main content Skip to footer

How to Import and Export CSV Files using Vue

Quick Start Guide
Tutorial Concept

Learn how to create a Vue CSV import/export Spreadsheet using SpreadJS to import and export CSV files directly in your web application.

What You Will Need

Vue.js Framework
NPM Packages:

  • @mescius/spread-sheets
  • @mescius/spread-sheets-vue

Node.js (version 14 or later)
Code Editor – Visual Studio Code

Controls Referenced

SpreadJS - Vue Spreadsheet Component
Vue Quick Start Guide | Documentation | getCsv method | setCsv method

A Vue spreadsheet component, such as SpreadJS, brings Excel-like spreadsheet power to modern web applications. In many projects, developers want a simple way to import CSV files into a spreadsheet-like interface and export edited data back as CSV. While the official documentation shows the basics of getCsv() and setCsv(), this article demonstrates a complete Vue I/O CSV workflow from project setup to interactive import/export buttons. You’ll learn how to read a CSV file into SpreadJS, edit the data visually, and export the results as a new CSV file.

Download a trial of the Vue spreadsheet component, SpreadJS, here!

Steps to Add CSV Import/Export Abilities to Vue Apps

  1. Create Your Vue Project for CSV Import/Export
  2. Install SpreadJS Packages
  3. Import SpreadJS in Your Vue App
  4. Add the SpreadJS Component to the Template
  5. Initialize the Spreadsheet
  6. Implement CSV Import Logic
  7. Implement CSV Export Logic
  8. Run Your Application

Download a final sample application here to follow along.


Create Your Vue Project for CSV Import/Export

Before integrating SpreadJS to create a CSV Import/Export application, you need a base Vue project. Vue.js provides a modern, reactive framework that makes building web applications fast and efficient.

Use the Vue CLI to quickly scaffold a new project. Open your terminal and run:

npm create vue@latest

During the setup process, the CLI will prompt you to configure your project. Here’s what you can select based on your requirements:

Create a Vue Spreadsheet Application

After completing the prompts, Vue will scaffold the project structure in a folder with your chosen name.

Once the project is created, navigate to your project folder:

cd <your-project-name>
npm install

Open your browser at http://localhost:5173. You should see your Vue application running, ready for integrating SpreadJS to create your interactive Vue CSV Import/Export application.

For guidance on getting started with Vue, please refer to our SpreadJS documentation ‘SpreadJS with Vue’.


Install SpreadJS Packages

SpreadJS provides a set of NPM packages for Vue that make integration smooth. To get started you will need the following:

Command:

npm install @mescius/spread-sheets @mescius/spread-sheets-vue

Import SpreadJS in Your Vue App

In this step, we set up SpreadJS in our Vue application by importing the necessary modules and styles into App.vue.

import "@mescius/spread-sheets/styles/gc.spread.sheets.excel2016colorful.css";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-vue";

Add the SpreadJS Component to the Template

The <gc-spread-sheets> component is the heart of your spreadsheet application, rendering a fully interactive Excel-like grid directly in your Vue app. The Import CSV button triggers a hidden file input to select CSV files, the Export CSV button converts the current spreadsheet into a CSV and downloads it, and the spreadsheet grid displays all the data in a fully editable format, allowing users to view, modify, and interact with the data seamlessly.

<template>
  <div>
    <div style="margin-bottom: 10px;">
      <input type="file" accept=".csv" ref="fileInput" style="display: none;" @change="handleFileImport" />
      <button @click="triggerImport">Import CSV</button>
      <button @click="exportCsv">Export CSV</button>
    </div>
    <gc-spread-sheets :hostClass="hostClass" @workbookInitialized="initWorkbook"></gc-spread-sheets>
  </div>
</template>

Initialize the Spreadsheet

Once the <gc-spread-sheets> component is loaded in your Vue app, you need to initialize the spreadsheet so it’s ready for user interaction. The @workbookInitialized event provides access to the SpreadJS workbook instance, allowing you to store it in a local variable and manipulate the active worksheet. In this step, we also set default values in the first few cells, so you can see that the spreadsheet is functional and interactive. This setup ensures that the grid is ready to import CSV data or export any changes made by you.

function initWorkbook(spreadInstance) {
  spread = spreadInstance;
  const sheet = spread.getActiveSheet();
  sheet.setValue(0, 0, "Hello SpreadJS + Vue!");
  sheet.setValue(1, 0, "Click 'Export CSV' to download this data.");
}

The image below shows the Vue CSV import/export spreadsheet running in the browser after setup.

Vue Application CSV Import and Export UI Example


Implement CSV Import Logic

To allow users to bring their CSV data into the spreadsheet, we implement a CSV import workflow. The Import CSV button triggers a hidden file input, letting users select a CSV file from their device. Once a file is chosen, the handleFileImport function reads its contents using a FileReader, clears any existing data in the spreadsheet, and then sets the CSV content into the active worksheet using SpreadJS’s setCsv method. This approach ensures the imported data appears correctly in the grid and allows users to start editing immediately.

function triggerImport() {
  document.querySelector('input[type="file"]').click();
}

function handleFileImport(event) {
  const file = event.target.files[0];
  if (!file) return;
  const reader = new FileReader();
  reader.onload = function(e) {
    const csvData = e.target.result;
    const sheet = spread.getActiveSheet();
    // Clear old data
    sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount());
    // Import CSV data
    sheet.setCsv(0, 0, csvData, "\r\n", ",");
  };
  reader.readAsText(file);
  event.target.value = "";
}

The GIF below shows the CSV import feature in action within the Vue application. After selecting a CSV file from the system, the data is instantly loaded into the spreadsheet grid, confirming that the import logic is functioning correctly and that the Vue CSV import/export setup using SpreadJS is successfully reading and displaying CSV content.

Imported CSV to Vue Spreadsheet Application


Implement CSV Export Logic

To enable users to save their spreadsheet data as a CSV file, we implement the CSV export workflow. When the Export CSV button is clicked, the exportCsv function retrieves the data from the active worksheet using SpreadJS’s getCsv method. This data is then converted into a downloadable CSV file using a Blob object. Finally, a temporary link is created and triggered programmatically, prompting the user to download the CSV file. This approach allows users to easily export their current spreadsheet content while preserving the layout and values exactly as displayed in the grid.

function exportCsv() {
  const sheet = spread.getActiveSheet();
  const csv = sheet.getCsv(0, 0, sheet.getRowCount(), sheet.getColumnCount(), "\r\n", ",");
  const blob = new Blob([csv], { type: "text/csv;charset=utf-8;" });
  const link = document.createElement("a");
  link.href = URL.createObjectURL(blob);
  link.download = "spreadsheet-export.csv";
  document.body.appendChild(link);
  link.click();
  document.body.removeChild(link);
}

After editing data in the spreadsheet, clicking the Export CSV button generates and downloads a CSV file, confirming that the export logic is functioning correctly and that the Vue CSV import/export workflow with SpreadJS allows users to easily save their spreadsheet data back to a CSV format.

Allow End-Users to Edit and Export CSV Data from Enterprise Vue Applications


Run Your Application

In this final step, you can start the Vue development server to see your CSV import/export functionality in action. With the project set up and all code in place, running npm run dev launches your Vue application locally. Once the server is running, open your browser and navigate to http://localhost:5173

Vue Spreadsheet Application Importing and Exporting CSV Files


Conclusion

SpreadJS combined with Vue provides a seamless way to handle CSV data directly in the browser, allowing developers to create interactive and responsive spreadsheet applications. With the ability to import and export CSV files efficiently, users can manage tabular data without relying on external software, making Vue CSV import/export a practical and powerful solution for web applications.

Tags:

comments powered by Disqus

Skip to main content Skip to footer
x

Win a free ActiveReports.NET v19 license!

Win a free ActiveReports license!

Win a free AR 19 license!

How to Import and Export CSV Files Using Angular

  • 0 Comments
Quick Start Guide
What You Will Need

SpreadJS

NPM

Angular v16

Visual Studio Code

Controls Referenced

SpreadJS

Tutorial Concept Import/Export CSV Angular - Add the functionality to import and export CSV files in an Angular spreadsheet application using SpreadJS features.

In the dynamic world of web development, Angular stands out as a powerful framework. As Angular developers, we frequently handle data in various formats, with CSV files a common requirement. Whether it's importing data from external sources, performing data analysis, or presenting information in a structured format, mastering CSV file manipulation is crucial. In this blog, we'll delve into handling CSV files using SpreadJS, a robust spreadsheet component for Angular. You'll learn how to import, visualize, and export CSV data seamlessly within an Angular application. Let's explore the capabilities of effortless CSV file management in Angular development.

Steps to Import and Export CSV Files in an Angular Spreadsheet Application

  1. Add SpreadJS to an Angular App
  2. Add Buttons for Import and Export
  3. Import CSV Data to Angular App Using SpreadJS’s setCsv Method
  4. Export Angular Data to a CSV File Using SpreadJS’s getCsv Method

To follow along with this tutorial, you can download the sample.

Ready to Get Started? Download SpreadJS Today!

Add SpreadJS to an Angular App

To get started with this example, create an angular app, reference SpreadJS’s files, and initialize the JavaScript spreadsheet component. In this case, we can use NPM to install the required SpreadJS files:

npm install @mescius/spread-sheets @mescius/spread-sheets-angular

We can now add the component to our app.component.html file for SpreadJS:

<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="workbookInit($event)"></gc-spread-sheets>

Then, in our app.component.ts file, we can add the imports that we will need:

import { Component } from '@angular/core';
import * as GC from "@mescius/spread-sheets";
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import { saveAs } from "file-saver";

We can then define the decorator and the variables for the component:

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [SpreadSheetsModule],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  spread: GC.Spread.Sheets.Workbook | null = null;
  hostStyle = {
    width: '800px',
    height: '600px'
  };
}

After that, we can add the initialization function for SpreadJS that we are referencing in the HTML file inside of the class definition:

workbookInit(args: { spread: GC.Spread.Sheets.Workbook; }) {
  this.spread = args.spread;
}

This is how the SpreadJS instance should look:

SJS Instance

Add Buttons for Import and Export

Next, we can add a button and a file selector element to our HTML page:

<input type="file" (change)="onFileChange($event)"/>
<button (click)="onExportCSV()">Export</button>

We then add the functions connected to these elements as well. For the export, we will add this function later in this blog, but for now, we need to add the event code for changing the file:

onFileChange(event: Event) {
  const input = event.currentTarget as HTMLInputElement;
  this.importCSV(input);
}

In this code, we simply retrieve the input from the event and pass it to the CSV importing function, which we will define in the next section. After adding the buttons, our page should look like this:

Buttons added

Import CSV Data to Angular App Using SpreadJS’s setCsv Method

To import CSV data, invoke SpreadJS’s setCsv method within the importCSV function. The setCsv method has a rowDelimiter and columnDelimiter as the fourth and fifth parameters, respectively. These can be changed to different symbols, like changing the columnDelimiter from “,” to “\t”, which will support TSV files as well. In the case of this example, we are just going to use commas. We need to retrieve the file from the input, read it as text, and then use setCsv:

importCSV(fileInput: HTMLInputElement) {
  if (fileInput.files && fileInput.files[0]) {
    let reader = new FileReader(), that = this;
    reader.onload = function (event: any) {
      let csv = event.target.result;
      that.spread?.getSheet(0).setCsv(0, 0, csv,'\r\n', ",");
    }
    reader.readAsText(fileInput.files[0])
  }
}

Export Angular Data to a CSV File Using SpreadJS’s getCsv Method

Alternatively, to export CSV data, we need to use the getCsv method within the exportCSV function. We can retrieve the CSV content with the getCsv method and then save it as a Blob type: 

onExportCSV() {
  let sheet = this.spread?.getActiveSheet();
  if (sheet) {
    let usedRange: GC.Spread.Sheets.Range = sheet.getUsedRange(GC.Spread.Sheets.UsedRangeType.data);
    let csv = sheet.getCsv(usedRange.row, usedRange.col, usedRange.rowCount, usedRange.colCount, "\r\n", ",");
    let blob = new Blob([csv], { type: "text/plain;charset=utf-8" });
    saveAs(blob, 'export-' + new Date().valueOf() + '.csv');
  }
}

That’s all that is needed to import and export CSV files with SpreadJS:

Import Export CSV

Ready to Try It Out? Download SpreadJS Today!

Conclusion

With a small amount of SpreadJS code, you can add CSV import and export functionality to your Angular app, providing your users the ability to load and save their data. For more information about SpreadJS and examples, check out our Demos and Documentation.

Tags:

Skip to main content Skip to footer

How to Import and Export CSV Files Using React

  • 0 Comments
Quick Start Guide
What You Will Need

SpreadJS

NPM

Visual Studio Code

Controls Referenced

SpreadJS

Tutorial Concept Learn how to import and export CSV files into a spreadsheet using React and SpreadJS.

In the dynamic world of web development, React is a powerful framework that allows you to build user interfaces out of individual pieces called components. As React developers, we typically handle data in various formats, with the CSV format as a common requirement. Whether it's importing data from external sources, performing data analysis, or presenting information in a structured format, mastering CSV file manipulation is crucial. In this blog, we'll delve into handling CSV files using SpreadJS, a robust spreadsheet component for React. You'll learn how to import, visualize, and export CSV data seamlessly within a React application. Let's explore the capabilities of effortless CSV file management in React development.

Steps to Import and Export CSV Files in a React Spreadsheet Application

  1. Add SpreadJS to a React App
  2. Add Buttons for Import and Export
  3. Import CSV Data to a React App Using SpreadJS’s setCsv Method
  4. Export React Data to a CSV File Using SpreadJS’s getCsv Method

To follow along with this tutorial, you can download this sample.

Ready to Get Started? Download SpreadJS Today!

Add SpreadJS to a React App

To start with this example, create a React app, reference SpreadJS' files, and initialize the JavaScript spreadsheet component. In this case, we can use NPM to install the required SpreadJS files:

npm install @mescius/spread-sheets @mescius/spread-sheets-react

We can now add the component to our App.js file under the render() function of the class:

class App extends React.Component {
...
  render() {
    return (
      <div>
        <SpreadSheets hostStyle={this.hostStyle} workbookInitialized={this.workbookInit}>
        </SpreadSheets>
      </div>
    )
  }
}

In that same file, we add all of the imports we will need above the class code:

import React from 'react';
import './App.css';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';

// Import file-saver module
import saveAs from 'file-saver';

After the imports, in the same file, we add a constructor to the class code and initialize a couple of variables:

class App extends React.Component {
  constructor(props) {
    super(props);
    this.hostStyle =
    {
      border: '1px solid #ccc',
      width: '100%',
      height: '80vh'
    };
    this.spread = null;
  }
  ...
}

After that, we add the initialization function for SpreadJS:

// Handling workbook initialized event
workbookInit = (spread) => {
  this.spread = spread;
}

The SpreadJS instance appears as below:

SpreadJS Instance

Add Buttons for Import and Export

Next, we will add a couple of buttons and a file selector element to the App.js file in the render function. This is as simple as adding some input elements in the div:

render() {
  return (
    <div>
      <input type="file" name="files[]" id="fileDemo" accept=".csv" />
      <input type="button" value="Import" onClick={this.importFile} />
      <input type="button" value="Export" onClick={this.exportFile} />
      <input type="text" id="exportFileName" placeholder="Export file name" value="export.csv" />
      <SpreadSheets hostStyle={this.hostStyle} workbookInitialized={this.workbookInit}>
      </SpreadSheets>
    </div>
  )
}

Import CSV Data to a React App Using SpreadJS’s setCsv Method

Now, we can add the functions connected to the elements we defined in the last section. To import CSV data to a React app, we will use the SpreadJS Workbook.import function:

// Import Csv
importFile = () => {
  var csvFile = document.getElementById("fileDemo").files[0];
  this.spread?.import(csvFile, function () {
    alert('Imported successfully');
  }, function () {
    alert('Import failed');
  }, {
    fileType: GC.Spread.Sheets.FileType.csv
  })
}

Export React Data to a CSV File Using SpreadJS’s getCsv Method

Alternatively, to export CSV data, we need to use the Workbook.export function within the exportFile function. We can export the CSV and save it as a Blob type:

// Export CSV
exportFile = () => {
  let fileName = document.getElementById("exportFileName").value;
  if (fileName.substr(-4, 4) !== '.csv') {
    fileName += '.csv';
  }
  this.spread?.export(function (blob) {
    saveAs(blob, fileName);
  }, function () {
    alert('Export failed');
  }, {
    fileType: GC.Spread.Sheets.FileType.csv
  })
}

That’s all that is needed to import and export CSV files with SpreadJS:

Import Export CSV

Ready to Try It Out? Download SpreadJS Today!

Conclusion

With a small amount of SpreadJS code, you can add CSV import and export functionality to your React app, providing your users the ability to load and save their data. For more information about SpreadJS and examples, check out our Demos and Documentation.

Tags: